
(defvar window-state-change-functions nil)

(defvar window-state-change-prev nil)

(defun window-state-change-pre-command ()
  (setq window-state-change-prev
        (mapcar (lambda (window)
                  `(,window
                    (buffer . ,(window-buffer window))
		    (selected . ,(eq window (selected-window)))
		    (start  . ,(window-start window))))
                (window-list nil 'nomini))))

(add-hook 'pre-command-hook 'window-state-change-pre-command)

(defun window-state-change-post-command ()
  (mapc (lambda (window)
          (let ((prev (cdr (assq window window-state-change-prev)))
                alist)
            (when prev
              (unless (eq       (cdr (assq 'buffer prev))  (window-buffer window))
                (push `(buffer ,(cdr (assq 'buffer prev)) ,(window-buffer window)) alist))
	      (unless (eq         (cdr (assq 'selected prev))  (eq window (selected-window)))
                (push `(selected ,(cdr (assq 'selected prev)) ,(eq window (selected-window))) alist))
              (unless (eq      (cdr (assq 'start prev))  (window-start window))
                (push `(start ,(cdr (assq 'start prev)) ,(window-start window)) alist)))
            (when alist
              (run-hook-with-args 'window-state-change-functions window alist))))
        (window-list nil 'nomini)))

(add-hook 'post-command-hook 'window-state-change-post-command)
